#if !defined(_IMPBRUSH_H)
#define _IMPBRUSH_H

#include <windows.h>
#include <gl/gl.h>
#include <gl/glu.h>
#include "impressionist.h"

#define DIR_SLIDER   0
#define DIR_RMOUSE   1 
#define DIR_BRUSH    2
#define DIR_GRADIENT 3


class CImpBrush 
{
protected:
	CImpBrush::CImpBrush(char* name = NULL );

public:
	/* Used to handle left mouse clicks */
	virtual void BrushBegin( POINT window, POINT canvas) {};
	virtual void BrushMove( POINT window, POINT canvas) {};
	virtual void BrushEnd( POINT window, POINT canvas ) {};

	/* Used to handle right mouse clicks. A brush can choose to
	 * implement these functions as it sees fit.*/
	virtual BOOL SelectBegin( POINT canvas) { return FALSE; };
	virtual void SelectMove( POINT canvas) {};
	virtual void SelectEnd( POINT canvas) {};

	/* Returns the color at the specified POINT on the original
	 * drawing */
	void SetColor( POINT canvas);
	char* BrushName( void );

	static int c_nBrushCount;
	static CImpBrush** c_pBrushes;

private:
	char* m_pBrushName;
};



#endif
